package com.jasamedika.medifirst2000.service.impl;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.orm.jpa.JpaSystemException;
import org.springframework.stereotype.Service;

import com.jasamedika.medifirst2000.converter.BaseConverterImpl;
import com.jasamedika.medifirst2000.dao.AntrianPasienDiPeriksaDao;
import com.jasamedika.medifirst2000.dao.KajianSistemDao;
import com.jasamedika.medifirst2000.dao.PraAnestesiDokterDao;
import com.jasamedika.medifirst2000.entities.KajianSistem;
import com.jasamedika.medifirst2000.entities.PraAnestesiDokter;
import com.jasamedika.medifirst2000.entities.StatusYaTidak;
import com.jasamedika.medifirst2000.exception.ServiceVOException;
import com.jasamedika.medifirst2000.service.KajianSistemService;
import com.jasamedika.medifirst2000.service.PasienDaftarService;
import com.jasamedika.medifirst2000.service.PraAnestesiDokterService;
import com.jasamedika.medifirst2000.util.CommonUtil;
import com.jasamedika.medifirst2000.vo.KajianSistemVO;
import com.jasamedika.medifirst2000.vo.PraAnestesiDokterVO;
import com.jasamedika.medifirst2000.vo.StatusYaTidakVO;

@Service("praAnestesiDokterService")
public class PraAnestesiDokterServiceImpl implements PraAnestesiDokterService{
	
	@Autowired
	private BaseConverterImpl<PraAnestesiDokterVO, PraAnestesiDokter> praAnestesiDokterConverter;
	
	@Autowired
	private BaseConverterImpl<KajianSistemVO, KajianSistem> kajianSistemConverter;
	
	@Autowired
	private PraAnestesiDokterDao praAnestesiDokterDao;
	
	@Autowired
	private KajianSistemService kajianSistemService;
	
	@Autowired
	private PasienDaftarService pasienDaftarService;

	@Override
	public PraAnestesiDokterVO add(PraAnestesiDokterVO vo) throws JpaSystemException, ServiceVOException {
		return null;
	}

	@Override
	public PraAnestesiDokterVO update(PraAnestesiDokterVO vo) throws JpaSystemException, ServiceVOException {
		return null;
	}

	@Override
	public Boolean delete(String key) throws JpaSystemException {
		return null;
	}

	@Override
	public PraAnestesiDokterVO findById(String key) throws JpaSystemException {
		return null;
	}

	@Override
	public List<PraAnestesiDokterVO> findAll() throws JpaSystemException {
		return null;
	}

	@Override
	public Map<String, Object> findAllWithPageAndLimitAndSortByAndDirectionParameter(Integer page, Integer limit,
			String sort, String dir) {
		return null;
	}

	public BaseConverterImpl<PraAnestesiDokterVO, PraAnestesiDokter> getPraAnestesiDokterConverter() {
		return praAnestesiDokterConverter;
	}

	public void setPraAnestesiDokterConverter(
			BaseConverterImpl<PraAnestesiDokterVO, PraAnestesiDokter> praAnestesiDokterConverter) {
		this.praAnestesiDokterConverter = praAnestesiDokterConverter;
	}
	@Autowired
	private AntrianPasienDiPeriksaDao antrianPasienDiPeriksaDao;
	@Override
	public Map<String, Object> save(PraAnestesiDokterVO vo) {
		Map<String, Object> result = new HashMap<String, Object>(); 
		PraAnestesiDokter praAnestesiDokter = praAnestesiDokterConverter.transferVOToModel(vo, new PraAnestesiDokter());
		if(CommonUtil.isNotNullOrEmpty(praAnestesiDokter))
		{
			praAnestesiDokter.setPasien(antrianPasienDiPeriksaDao.findbyNoCmAndTglRegistrasi(vo.getPasien().getId(), vo.getTglRegistrasi()));	
			PraAnestesiDokter resultModel = praAnestesiDokterDao.save(praAnestesiDokter);
			if(CommonUtil.isNotNullOrEmpty(resultModel)){
				result.put("id", resultModel.getNoRec());
				result.put("Nama Pasien", resultModel.getPasien().getPasienDaftar().getPasien().getNamaPasien());
			}
		}
		
		return result;
	}

	
}
